<%@ Page Language="C#"%>
<%@ Import Namespace="System.IO" %>
<%@ Import Namespace="System.Runtime.Serialization" %>
<%@ Import Namespace="System.Runtime.Serialization.Formatters.Binary" %>
<%@ Import Namespace="System.Drawing" %>

<script runat=server>

string[,] arrCalendar = new string[13,32];

// get  schedule from cache or disk
void Page_Load (Object sender , EventArgs e)  {
   FileStream strmFileStream;
   BinaryFormatter fmtrBinaryFormatter;

  if ( Cache[ "arrCalendar" ] == null ) {
    if ( File.Exists( "c:\\schedule.bin" ) ) {
      strmFileStream =        new FileStream( "c:\\schedule.bin", FileMode.Open );
      fmtrBinaryFormatter = new BinaryFormatter();
      arrCalendar =  (string[,]) fmtrBinaryFormatter.Deserialize( strmFileStream );
      strmFileStream.Close();
      Cache[ "arrCalendar" ] = arrCalendar;
    }
  } else {
    arrCalendar = (string[,])Cache[ "arrCalendar" ];
  }
}

// Save schedule to file
void btnSave_Click( object s, EventArgs e ) {
   DateTime dtmDate;
   FileStream strmFileStream;
   BinaryFormatter fmtrBinaryFormatter;

  dtmDate = calSchedule.SelectedDate;
  arrCalendar[ dtmDate.Month, dtmDate.Day ] = txtNotes.Text;
  strmFileStream =    new FileStream( "c:\\schedule.bin", FileMode.Create );
  fmtrBinaryFormatter = new BinaryFormatter();
  fmtrBinaryFormatter.Serialize( strmFileStream, arrCalendar );
  strmFileStream.Close();
  Cache[ "arrCalendar" ] = arrCalendar;
}

// Pick a date
void Calendar_SelectionChanged( object s, EventArgs e ) {
   DateTime dtmDate;

  dtmDate = calSchedule.SelectedDate;
  txtNotes.Text = arrCalendar[ dtmDate.Month, dtmDate.Day ];
}

// Display each calendar day
void Calendar_RenderDay( object s, DayRenderEventArgs e ) {
   DateTime dtmDate;
   TableCell ctlCell;

  dtmDate = e.Day.Date;
  ctlCell = e.Cell;
  if ( arrCalendar[ dtmDate.Month, dtmDate.Day ] != null ) {
    ctlCell.BackColor = Color.FromName( "Orange" );
  }
}
</Script>

<html>
<head><title>CalendarSchedule.aspx</title></head>
<body>

<form Runat="Server">

<asp:Calendar
  id="calSchedule"
  Width="100%"
  ShowGridLines="True"
  OnSelectionChanged="Calendar_SelectionChanged"
  OnDayRender="Calendar_RenderDay"
  Runat="Server" />

<p>
<asp:TextBox
  id="txtNotes"
  TextMode="MultiLIne"
  Columns="50"
  Rows="10"
  Runat="Server" />

<p>
<asp:Button
  id="btnSave"
  Text="Save Changes"
  OnClick="btnSave_Click"
  Runat="Server" />

</form>
</body>
</html>
