<%@ Import Namespace="System.Data.SqlClient" %>

<Script Runat="Server">

Dim conNorthwind As SqlConnection
Dim cmdSql As SqlCommand
Dim strSql As String

Sub Page_Load
  conNorthwind = New SqlConnection( "Server=localhost;UID=sa;PWD=secret;Database=Northwind" )
  If Not IsPostBack Then
    BindDataGrid
  End If
End Sub

Sub BindDataGrid
  cmdSql = New SqlCommand( "Select * From Products", conNorthwind )
  conNorthwind.Open()
  dgrdProducts.DataSource = cmdSql.ExecuteReader()
  dgrdProducts.DataBind()
  conNorthwind.Close()
End Sub

Sub dgrdProducts_EditCommand( s As Object, e As DataGridCommandEventArgs )
  dgrdProducts.EditItemIndex = e.Item.ItemIndex
  BindDataGrid
End Sub

Sub dgrdProducts_UpdateCommand( s As Object, e As DataGridCommandEventArgs )
  Dim intProductID As Integer
  Dim txtProductName As TextBox
  Dim txtUnitPrice As TextBox
  Dim strProductName As String
  Dim decUnitPrice As Decimal

  intProductID = dgrdProducts.DataKeys( e.Item.ItemIndex )
  txtProductName = e.Item.Cells( 1 ).Controls( 0 )
  txtUnitPrice = e.Item.Cells( 2 ).Controls( 0 )
  strProductName = txtProductName.Text
  decUnitPrice = txtUnitPrice.Text
  strSql = "Update Products Set ProductName=@ProductName, " _
   & "UnitPrice=@UnitPrice Where ProductID=@ProductID"
  cmdSql = New SqlCommand( strSql, conNorthwind )
  cmdSql.Parameters.Add( "@ProductName", strProductName )
  cmdSql.Parameters.Add( "@UnitPrice", decUnitPrice )
  cmdSql.Parameters.Add( "@ProductID", intProductID )
  conNorthwind.Open()
  cmdSql.ExecuteNonQuery()
  conNorthwind.Close()
  dgrdProducts.EditItemIndex = -1
  BindDataGrid
End Sub

Sub dgrdProducts_CancelCommand( s As Object, e As DataGridCommandEventArgs )
  dgrdProducts.EditItemIndex = -1
  BindDataGrid
End Sub

</Script>

<html>
<head><title>DataGridEditProducts.aspx</title></head>
<body>
<form Runat="Server">

<asp:DataGrid
  ID="dgrdProducts"
  OnEditCommand="dgrdProducts_EditCommand"
  OnUpdateCommand="dgrdProducts_UpdateCommand"
  OnCancelCommand="dgrdProducts_CancelCommand"
  DataKeyField="ProductID"
  AutoGenerateColumns="False"
  CellPadding="10"
  HeaderStyle-BackColor="Salmon"
  Runat="Server">
<Columns>
  <asp:BoundColumn
    HeaderText="Product ID"
    DataField="ProductID"
    ReadOnly="True" />
  <asp:BoundColumn
    HeaderText="Product Name"
    DataField="ProductName" />
  <asp:BoundColumn
    HeaderText="Price"
    DataField="UnitPrice"
    DataFormatString="{0:c}" />
  <asp:EditCommandColumn
    EditText="Edit!"
    UpdateText="Update!"
    CancelText="Cancel!" />
</Columns>
</asp:DataGrid>

</form>
</body>
</html>
