﻿<%@ Page Language="C#" %>
<Script Runat="Server">

SixDegrees  objSixDegrees = new SixDegrees();
GetLinksMatches  objMatches = new GetLinksMatches();
Random  objRandom = new Random();
ArrayList  colHistory = new ArrayList();

void Button_Click( object s, EventArgs e ) {
  objSixDegrees.UserAgent = "SixDegrees";
  objSixDegrees.Timeout = 5000;
  objSixDegrees.AllowAutoRedirect = true;
  GetNextLink( txtUrl.Text );
  dgrdHistory.DataSource = colHistory;
  dgrdHistory.DataBind();
}

void GetNextLink( string strCurrentLink ) {
   string  strNextLink;

  colHistory.Add( strCurrentLink );
  objSixDegrees.Url = strCurrentLink;

  try {
    objMatches = objSixDegrees.GetLinks();
  } catch (Exception ex) {
    colHistory.Add( ex.Message );
  }

  if (! ( objMatches.Links == null ) && colHistory.Count < 25 ) {
    if ( objRandom.Next(2) == 1) {
      Array.Reverse( objMatches.Links );
    }

    foreach ( string link in objMatches.Links)
    {
      if ( link.ToLower() != strCurrentLink.ToLower() )
      {
        GetNextLink( link );
      }
    } 
  }
}

</Script>

<html>
<head><title>DisplaySixDegrees.aspx</title></head>
<body>

<h2>Six Degrees of Separation</h2>

<form runat="Server">

<asp:TextBox
  id="txtUrl"
  Columns="40"
  Text="http://"
  Runat="Server" />

<asp:Button
  Text="Go!"
  OnClick="Button_Click"
  Runat="Server"/>

</form>
<p>
<asp:DataList
  id="dgrdHistory"
  CellPadding="6"
  Gridlines="Both"
  AlternatingItemStyle-BackColor="lightblue"
  Runat="Server">
  <ItemTemplate>
    <%# Container.ItemIndex %> -
    <asp:HyperLink
      Text='<%# Container.DataItem %>'
      NavigateUrl='<%# Container.DataItem %>' 
      Runat="Server" />
  </ItemTemplate>
</asp:DataList>


</body>
</html>