<%@ Page Language="C#" debug="true" %>
<%@ Register TagPrefix="myControls" Namespace="myControls" Assembly="DataBoundDataSet"%>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.Common" %>
<%@ Import Namespace="System.Data.SqlClient" %>

<Script Runat="Server">

private void Page_Load(object sender, EventArgs e) {
  if (!IsPostBack) {
	SqlConnection conPubs;
	SqlDataAdapter dadAdapter;
	DataSet dstDataSet;
	SqlCommand cmdSelect;
	ArrayList colArrayList;
	
    conPubs = new SqlConnection( @"Server=localhost;trusted_connection=true;Database=Pubs" );
    conPubs.Open();

    // Create a dataset with 2 DataTables
    dadAdapter = new SqlDataAdapter( "Select top 3 * From Titles", conPubs );
    dstDataSet = new DataSet();
    dadAdapter.Fill( dstDataSet, "Titles" );
    dadAdapter.SelectCommand = new SqlCommand( "Select top 3 * From Authors", conPubs );
    dadAdapter.Fill( dstDataSet, "Authors" );

    // Bind with DataSet and no DataMember
    ctrlDataBound1.DataSource = dstDataSet;
    ctrlDataBound1.DataBind();

    // Bind with DataSet and explicit DataMember
    ctrlDataBound2.DataSource = dstDataSet;
    ctrlDataBound2.DataMember = "Authors" ;
    ctrlDataBound2.DataBind();
    
    // Bind to DataReader
    cmdSelect = new SqlCommand( "Select top 3 * From Titles", conPubs );
    ctrlDataBound3.DataSource = cmdSelect.ExecuteReader();
    ctrlDataBound3.DataBind();

    // Bind to ArrayList
    colArrayList = new ArrayList();
    colArrayList.Add( "Milk" );
    colArrayList.Add( "Toast" );
    ctrlDataBound4.DataSource = colArrayList;
    ctrlDataBound4.DataBind();

    conPubs.Close();
  }
}
</Script>

<html>
<head><title>DisplayDataBoundDataSet.aspx</title></head>
<body>
<form Runat="Server">

<h3>DataSet and no DataMember</h2>
<myControls:DataBoundDataSet
  ID="ctrlDataBound1"
  Runat="Server">
  <ItemTemplate>
    <li> <i><%# ((DataRowView)Container.DataItem)["Title"] %></i>
  </ItemTemplate>
</myControls:DataBoundDataSet>

<h3>DataSet with DataMember</h2>
<myControls:DataBoundDataSet
  ID="ctrlDataBound2"
  Runat="Server">
  <ItemTemplate>
    <li> <i><%# ((DataRowView)Container.DataItem)["au_lname"] %></i>
  </ItemTemplate>
</myControls:DataBoundDataSet>

<h3>DataReader</h2>
<myControls:DataBoundDataSet
  ID="ctrlDataBound3"
  Runat="Server">
  <ItemTemplate>
    <li> <i><%# ((DbDataRecord)Container.DataItem)["Title"] %></i>
  </ItemTemplate>
</myControls:DataBoundDataSet>

<h3>ArrayList</h2>
<myControls:DataBoundDataSet
  ID="ctrlDataBound4"
  Runat="Server">
  <ItemTemplate>
    <li> <i><%# Container.DataItem %></i>
  </ItemTemplate>
</myControls:DataBoundDataSet>

</form>
</body>
</html>
