<%@ Register TagPrefix="myControls" Namespace="myControls"
Assembly="DataBoundDataSet"%>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>

<Script Runat="Server">

Sub Page_Load
  If Not IsPostBack Then
    Dim conPubs As SqlConnection
    Dim dadAdapter As SqlDataAdapter
    Dim dstDataSet As DataSet
    Dim cmdSelect As SqlCommand
    Dim colArrayList As ArrayList

    conPubs = New SqlConnection( "Server=LocalHost;UID=sa;PWD=secret;Database=Pubs" )
    conPubs.Open()

    ' Create a dataset with 2 DataTables
    dadAdapter = New SqlDataAdapter( "Select top 3 * From Titles", conPubs )
    dstDataSet = New DataSet()
    dadAdapter.Fill( dstDataSet, "Titles" )
    dadAdapter.SelectCommand = New SqlCommand( "Select top 3 * From Authors", conPubs )
    dadAdapter.Fill( dstDataSet, "Authors" )

    ' Bind with DataSet and no DataMember
    ctrlDataBound1.DataSource = dstDataSet
    ctrlDataBound1.DataBind()

    ' Bind with DataSet and explicit DataMember
    ctrlDataBound2.DataSource = dstDataSet
    ctrlDataBound2.DataMember = "Authors" 
    ctrlDataBound2.DataBind()
    
    ' Bind to DataReader
    cmdSelect = New SqlCommand( "Select top 3 * From Titles", conPubs )
    ctrlDataBound3.DataSource = cmdSelect.ExecuteReader()
    ctrlDataBound3.DataBind()

    ' Bind to ArrayList
    colArrayList = New ArrayList
    colArrayList.Add( "Milk" )
    colArrayList.Add( "Toast" )
    ctrlDataBound4.DataSource = colArrayList
    ctrlDataBound4.DataBind()    

    conPubs.Close
  End If
End Sub
</Script>

<html>
<head><title>DisplayDataBoundDataSet.aspx</title></head>
<body>
<form Runat="Server">

<h3>DataSet and no DataMember</h2>
<myControls:DataBoundDataSet
  ID="ctrlDataBound1"
  Runat="Server">
  <ItemTemplate>
    <li> <i><%# Container.DataItem( "Title" ) %></i>
  </ItemTemplate>
</myControls:DataBoundDataSet>

<h3>DataSet with DataMember</h2>
<myControls:DataBoundDataSet
  ID="ctrlDataBound2"
  Runat="Server">
  <ItemTemplate>
    <li> <i><%# Container.DataItem( "au_lname" ) %></i>
  </ItemTemplate>
</myControls:DataBoundDataSet>

<h3>DataReader</h2>
<myControls:DataBoundDataSet
  ID="ctrlDataBound3"
  Runat="Server">
  <ItemTemplate>
    <li> <i><%# Container.DataItem( "Title" ) %></i>
  </ItemTemplate>
</myControls:DataBoundDataSet>

<h3>ArrayList</h2>
<myControls:DataBoundDataSet
  ID="ctrlDataBound4"
  Runat="Server">
  <ItemTemplate>
    <li> <i><%# Container.DataItem %></i>
  </ItemTemplate>
</myControls:DataBoundDataSet>

</form>
</body>
</html>
