using myControls;
using System;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.Services;
using System.Data;



namespace myControls {
 
	public class NewJobs : WebControl {
		public int PageSize = 5;
		const string aspnetjobsUrl = "http://localhost/AspNetJobs";

		protected override void CreateChildControls() {
			DataGrid dgrdNewJobs;
			BoundColumn objBoundColumn;
			HyperLinkColumn objHyperLinkColumn;

			// Build DataGrid
			dgrdNewJobs = new DataGrid();
			dgrdNewJobs.ID = "NewJobsGrid";
			dgrdNewJobs.AllowPaging = true;
			dgrdNewJobs.PageSize = PageSize;
			dgrdNewJobs.PagerStyle.Visible = false;
			dgrdNewJobs.CellPadding = 4;
			dgrdNewJobs.BorderStyle = BorderStyle.Solid;
			dgrdNewJobs.AutoGenerateColumns = false;
			dgrdNewJobs.ShowHeader = false;
			dgrdNewJobs.GridLines = GridLines.None;
    
			// Add Date Column
			objBoundColumn = new BoundColumn();
			objBoundColumn.DataField = "job_entrydate";
			objBoundColumn.DataFormatString = "{0:m}";
			dgrdNewJobs.Columns.Add( objBoundColumn );
    
			// Add HyperLink Column
			objHyperLinkColumn = new HyperLinkColumn();
			objHyperLinkColumn.DataTextField = "job_briefdesc";
			objHyperLinkColumn.DataNavigateUrlField = "job_id";
			objHyperLinkColumn.DataNavigateUrlFormatString = aspnetjobsUrl + "site/job.aspx?id={0}";
			dgrdNewJobs.Columns.Add( objHyperLinkColumn );

			// Bind DataGrid
			dgrdNewJobs.DataSource = GetNewJobs();
			dgrdNewJobs.DataBind() ;

			// Add Child Controls
			Controls.Add( new LiteralControl( "<b>new Jobs!<b>" ) );
			Controls.Add( dgrdNewJobs );
		}

		private DataSet GetNewJobs() {
			DataSet dstJobs;
			JobService objJobService;

			dstJobs = (DataSet)Context.Cache["JobService_NewJobs"];
			if ( dstJobs == null ) {
				objJobService = new JobService();
				dstJobs = objJobService.GetNewJobs();
				Context.Cache.Insert("JobService_NewJobs", dstJobs, null, DateTime.Now.AddMinutes( 15 ), TimeSpan.Zero );
			}
			return dstJobs;
		}
	}


	public class NewResumes  : WebControl {
		public int PageSize = 5;
		const string aspnetjobsUrl = "http://localhost/AspNetJobs";

		protected override void CreateChildControls() {
			DataGrid dgrdNewResumes;
			BoundColumn objBoundColumn;
			HyperLinkColumn objHyperLinkColumn;

			// Build DataGrid
			dgrdNewResumes = new DataGrid();
			dgrdNewResumes.ID = "NewResumesGrid";
			dgrdNewResumes.AllowPaging = true;
			dgrdNewResumes.PageSize = PageSize;
			dgrdNewResumes.PagerStyle.Visible = false;
			dgrdNewResumes.CellPadding = 4;
			dgrdNewResumes.BorderStyle = BorderStyle.Solid;
			dgrdNewResumes.AutoGenerateColumns = false;
			dgrdNewResumes.ShowHeader = false;
			dgrdNewResumes.GridLines = GridLines.None;
    
			// Add Date Column
			objBoundColumn = new BoundColumn();
			objBoundColumn.DataField = "ul_entrydate";
			objBoundColumn.DataFormatString = "{0:m}";
			dgrdNewResumes.Columns.Add( objBoundColumn );
    
			// Add HyperLink Column
			objHyperLinkColumn = new HyperLinkColumn();
			objHyperLinkColumn.DataTextField = "ul_briefdesc";
			objHyperLinkColumn.DataNavigateUrlField = "ul_username";
			objHyperLinkColumn.DataNavigateUrlFormatString = aspnetjobsUrl + "{0}.aspx";
			dgrdNewResumes.Columns.Add( objHyperLinkColumn );

			// Bind DataGrid
			dgrdNewResumes.DataSource = GetNewResumes();
			dgrdNewResumes.DataBind() ;

			// Add Child Controls
			Controls.Add( new LiteralControl( "<b>new Resumes!<b>" ) );
			Controls.Add( dgrdNewResumes );
		}

		private DataSet GetNewResumes() {
			DataSet dstResumes;
			JobService objJobService;

			dstResumes = (DataSet)Context.Cache["JobService_NewResumes"];
			if ( dstResumes == null ) {
				objJobService = new JobService();
				dstResumes = objJobService.GetNewResumes();
				Context.Cache.Insert("JobService_NewResumes",  dstResumes, null, DateTime.Now.AddMinutes( 15 ), TimeSpan.Zero );
			}
			return dstResumes;
		}
	}
}