<!-- #INCLUDE Virtual="/aspnetjobs/site/includes/header.aspx" -->

<Script Runat="Server">

Dim intJobID As Integer
Dim strUsername As String

Sub Page_Load
  Dim strConString As String
  Dim conJobs As SqlConnection
  Dim cmdSelect As SqlCommand
  Dim dtrDataReader As SqlDataReader

  ' Get Job ID
  intJobID = Request.QueryString( "id" )

  ' Create Apply Link
  lnkApply.NavigateURL = _
    String.Format( _
      "/aspnetjobs/site/password/apply.aspx?id={0}", _
      intJobID )

  ' Get Job From Database
  strConString = ConfigurationSettings.AppSettings( "constring" )
  conJobs = New SqlConnection( strConString )
  cmdSelect = New SqlCommand( "getJob", conJobs )
  cmdSelect.CommandType = CommandType.StoredProcedure
  cmdSelect.Parameters.Add( "@jobid", intJobID )
  conJobs.Open()
    dtrDataReader = cmdSelect.ExecuteReader()
    If dtrDataReader.Read() Then
      ctrlHeader.PageTitle = dtrDataReader( "Job_briefdesc" )
      lblJobBriefDesc.Text = dtrDataReader( "job_briefdesc" )
      lblJobFullDesc.Text = dtrDataReader( "job_fulldesc" )
      lblJobEntryDate.Text = dtrDataReader( "job_entrydate" )
      strUsername = dtrDataReader( "job_username" )
    End If
    dtrDataReader.Close()
    ' Get Job Applications
    If Page.User.Identity.IsAuthenticated _
      AND Page.User.Identity.Name.ToLower = strusername.ToLower Then
      cmdSelect.CommandText = "getApplications"
      dtrDataReader = cmdSelect.ExecuteReader()
      dgrdApplications.Datasource = dtrDataReader
      dgrdApplications.Databind()
      dtrDataReader.Close
    End If
  conJobs.Close()
  lnkJobUsername.Text = _
    String.Format( "{0} ({0}.aspx)", strUsername )
  lnkJobUsername.NavigateUrl = _
    String.Format( "/aspnetjobs/{0}.aspx", strUsername )
End Sub

Sub UpdatePage( s As Object, e As EventArgs )
  pnlUpdatePage.Visible = True  
  txtJobFullDesc.Text = lblJobFullDesc.Text
  txtJobBriefDesc.Text = lblJobBriefDesc.Text
  pnlViewPage.Visible = False
End Sub

Sub Page_PreRender
  ' Check if This is User's Page
  If ctrlUserLinks.IsAuthenticated Then
    If Page.User.Identity.Name.ToLower = strUsername.ToLower Then
      pnlUserIntro.Visible = True
      pnlViewApplications.Visible = True
    End If 
  Else
    pnlUserIntro.Visible = False
    pnlViewPage.Visible = True
    pnlUpdatePage.Visible = False
    pnlViewApplications.Visible = False
  End If
End Sub

Sub SaveJob( s As Object, e As EventArgs )
  Dim conJobs As SqlConnection
  Dim strConString As String
  Dim cmdUpdate As SqlCommand

  If Page.User.Identity.IsAuthenticated Then
    strConString = ConfigurationSettings.AppSettings( "constring" )
    conJobs = New SqlConnection( strConString )
    cmdUpdate = New SqlCommand( "updateJob", conJobs )
    cmdUpdate.CommandType = CommandType.StoredProcedure
    cmdUpdate.Parameters.Add( "@jobID", intJobID )
    cmdUpdate.Parameters.Add( "@briefdesc", txtJobBriefDesc.Text )
    cmdUpdate.Parameters.Add( "@fulldesc", txtJobFullDesc.Text )
    conJobs.Open()
      cmdUpdate.ExecuteNonQuery()
    conJobs.Close()
    pnlViewPage.Visible = True
    lblJobBriefDesc.Text = txtJobBriefDesc.Text
    lblJobFullDesc.Text = txtJobFullDesc.Text
    ctrlHeader.PageTitle = txtJobBriefDesc.Text
    pnlUpdatePage.Visible = False
  End If
End Sub

</Script>

<myControls:Header
  ID="ctrlHeader"
  Runat="Server" />
<form runat="Server">
<myControls:UserLinks
  ID="ctrlUserLinks"
  Runat="Server" />
<br clear="all">
<asp:Panel
  ID="pnlUserIntro"
  Visible="False"
  CssClass="UserInfoPanel"
  Runat="Server">
Hi <%=strUsername%>! Welcome to your job page!
<br>
If you would like to update the contents of
this page, 
<asp:LinkButton
  Text="click here."
  OnClick="UpdatePage"
  Runat="Server" />
</asp:Panel>

<%-- View Page Panel --%>
<asp:Placeholder
  ID="pnlViewPage"
  Runat="Server">
<asp:Label
  ID="lblJobBriefDesc"
  CssClass="TopHeading"
  Runat="Server" />
<table cellspacing=5 cellpadding=5 border=0>
<tr><td valign="top" width="500" bgcolor="#eeeeee">
<asp:Label
  ID="lblJobFullDesc"
  Runat="Server" />
</asp:Placeholder>

<%-- Update Job Panel --%>
<asp:Placeholder
  ID="pnlUpdatePage"
  Visible="False"
  Runat="Server">
<table cellspacing=10 border=0>
<tr><td valign="top" width="500">
<b>Job Brief Description</b>
<br>
<asp:TextBox
  ID="txtJobBriefDesc"
  Columns="50"
  CssClass="formfield"
  runat="Server" />
<p>
<b>Job Full Description</b>
<br>
<asp:TextBox
  ID="txtJobFullDesc"
  TextMode="Multiline"
  Columns="60"
  Rows="10"
  CssClass="formfield"
  Runat="Server" />
<br>
<asp:Button
  Text="Save!"
  OnClick="SaveJob"
  Runat="Server" />
</asp:Placeholder>

<p>
<b>Listed On</b>
<br>
<asp:Label
  ID="lblJobEntryDate"
  Runat="Server" />
<p>
<b>Listed By</b>
<br>
<asp:HyperLink
  ID="lnkJobUsername"
  Runat="Server" />

</td><td valign="top">

<asp:HyperLink
  ID="lnkApply"
  Text="Apply"
  Runat="Server" />
<br>
Click here to apply for this job

<asp:Panel
  ID="pnlViewApplications"
  CssClass="UserInfoPanel"
  Visible="False"
  Runat="Server">
<b>View Applications</b>
<br>
<asp:DataGrid
  ID="dgrdApplications"
  GridLines="None"
  font-size="10pt"
  AutoGenerateColumns="False"
  ShowHeader="False"
  Cellpadding="3"
  Runat="Server">
<Columns>
<asp:BoundColumn
  DataField="app_entrydate"
  DataFormatString="{0:m}" />
<asp:HyperLinkColumn
  DataTextField="app_from"
  DataNavigateUrlField="app_id" 
  DataNavigateUrlFormatString="/aspnetjobs/site/password/viewapplication.aspx?id={0}"/>
</Columns>
</asp:DataGrid>
</asp:Panel>

</td></tr>
</table>
</form>
<myControls:Footer
  Runat="Server" />