Imports myControls
Imports System
Imports System.Web
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.Services
Imports System.Data

Namespace myControls

Public Class NewJobs: Inherits WebControl

  Const aspnetjobsUrl = "http://localhost/aspnetjobs/"

  Public PageSize AS Integer = 5

  Protected Overrides Sub CreateChildControls
    Dim dgrdNewJobs As DataGrid
    Dim objBoundColumn As BoundColumn
    Dim objHyperLinkColumn As HyperLinkColumn

    ' Build DataGrid
    dgrdNewJobs = New DataGrid
    dgrdNewJobs.ID = "NewJobsGrid"
    dgrdNewJobs.AllowPaging = True
    dgrdNewJobs.PageSize = PageSize
    dgrdNewJobs.PagerStyle.Visible = False
    dgrdNewJobs.Cellpadding = 4
    dgrdNewJobs.BorderStyle = BorderStyle.Solid
    dgrdNewJobs.AutoGenerateColumns = False
    dgrdNewJobs.ShowHeader = False
    dgrdNewJobs.GridLines = GridLines.None
    ' Add Date Column
    objBoundColumn = New BoundColumn()
    objBoundColumn.DataField = "job_entrydate"
    objBoundColumn.DataFormatString = "{0:m}"
    dgrdNewJobs.Columns.Add( objBoundColumn )
    ' Add HyperLink Column
    objHyperLinkColumn = New HyperlinkColumn
    objHyperLinkColumn.DataTextField = "job_briefdesc"
    objHyperLinkColumn.DataNavigateUrlField = "job_id"
    objHyperLinkColumn.DataNavigateUrlFormatString = _
      aspnetjobsUrl & "site/job.aspx?id={0}"
    dgrdNewJobs.Columns.Add( objHyperLinkColumn )

    ' Bind DataGrid
    dgrdNewJobs.Datasource = GetNewJobs()
    dgrdNewJobs.Databind() 

    ' Add Child Controls
    Controls.Add( New LiteralControl( "<b>New Jobs!<b>" ) )
    Controls.Add( dgrdNewJobs )
  End Sub

  Private Function GetNewJobs() As DataSet
    Dim dstJobs As DataSet
    Dim objJobService As JobService

    dstJobs = Context.Cache( "JobService_NewJobs" )
    If dstJobs Is Nothing Then
      objJobService = New JobService
      dstJobs = objJobService.GetNewJobs()
      Context.Cache.Insert( _
        "JobService_NewJobs", _
        dstJobs, _
        Nothing, _
        DateTime.Now.AddMinutes( 15 ), _
        Timespan.Zero )
    End If
    Return dstJobs
  End Function
End Class


Public Class NewResumes : Inherits WebControl

  Const aspnetjobsUrl = "http://localhost/aspnetjobs/"

  Public PageSize AS Integer = 5

  Protected Overrides Sub CreateChildControls
    Dim dgrdNewResumes As DataGrid
    Dim objBoundColumn As BoundColumn
    Dim objHyperLinkColumn As HyperLinkColumn

    ' Build DataGrid
    dgrdNewResumes = New DataGrid
    dgrdNewResumes.ID = "NewResumesGrid"
    dgrdNewResumes.AllowPaging = True
    dgrdNewResumes.PageSize = PageSize
    dgrdNewResumes.PagerStyle.Visible = False
    dgrdNewResumes.Cellpadding = 4
    dgrdNewResumes.BorderStyle = BorderStyle.Solid
    dgrdNewResumes.AutoGenerateColumns = False
    dgrdNewResumes.ShowHeader = False
    dgrdNewResumes.GridLines = GridLines.None
    ' Add Date Column
    objBoundColumn = New BoundColumn()
    objBoundColumn.DataField = "ul_entrydate"
    objBoundColumn.DataFormatString = "{0:m}"
    dgrdNewResumes.Columns.Add( objBoundColumn )
    ' Add HyperLink Column
    objHyperLinkColumn = New HyperlinkColumn
    objHyperLinkColumn.DataTextField = "ul_briefdesc"
    objHyperLinkColumn.DataNavigateUrlField = "ul_username"
    objHyperLinkColumn.DataNavigateUrlFormatString = _
      aspnetjobsurl & "{0}.aspx"
    dgrdNewResumes.Columns.Add( objHyperLinkColumn )

    ' Bind DataGrid
    dgrdNewResumes.Datasource = GetNewResumes()
    dgrdNewResumes.Databind() 

    ' Add Child Controls
    Controls.Add( New LiteralControl( "<b>New Resumes!<b>" ) )
    Controls.Add( dgrdNewResumes )
  End Sub

  Private Function GetNewResumes() As DataSet
    Dim dstResumes As DataSet
    Dim objJobService As JobService

    dstResumes = Context.Cache( "JobService_NewResumes" )
    If dstResumes Is Nothing Then
      objJobService = New JobService
      dstResumes = objJobService.GetNewResumes()
      Context.Cache.Insert( _
        "JobService_NewResumes", _
        dstResumes, _
        Nothing, _
        DateTime.Now.AddMinutes( 15 ), _
        Timespan.Zero )
    End If
    Return dstResumes
  End Function
End Class

End Namespace