<%@ Import Namespace="StoreComponents" %>

<script language="C#" runat=server>

int intProductID;
 int intCategory;
 string  strProductName="Beverages";
 Decimal decUnitPrice = 0;
 ShoppingCart objShoppingCart;

void Page_Load(Object sender , EventArgs e) 
{
  if (Context.Items["ProductInfo"] != null) {
	intProductID = System.Convert.ToInt32(Context.Items[ "ProductID" ]);
	intCategory = System.Convert.ToInt32(Context.Items[ "Category" ]);
	strProductName = (String)(Context.Items[ "ProductName" ]);
	decUnitPrice = (Decimal)(Context.Items[ "UnitPrice" ]);
  }

  objShoppingCart = new ShoppingCart();

  if (! IsPostBack ) {
    if ( intProductID == -1 ) {
      btnAdd.Visible = false;
    }
    BindDataGrid() ;
  }
}  

void Page_PreRender(Object sender , EventArgs e)  {
  
  if ( objShoppingCart.Items.Count == 0 )
  {
    btnCheckOut.Visible = false;
  } 
  else
  { 
    btnCheckOut.Visible = true;
    btnCheckOut.NavigateUrl = string .Format("~/CheckOut.aspx?cat={0}", intCategory );
  }
}


void btnAdd_Click( object s, EventArgs e )
{
	if (Context.Items["ProductInfo"] != null) {
		objShoppingCart.Add( intProductID, strProductName, decUnitPrice );
		BindDataGrid() ;
	}
}

void LinkButton_Click( object s, DataGridCommandEventArgs e )
{
  objShoppingCart.Remove( e.Item.ItemIndex );
  BindDataGrid();
}

void BindDataGrid () {
  dgrdShoppingCart.DataSource = objShoppingCart.Items;
  dgrdShoppingCart.DataBind();
}
</Script>

<table>
<tr>
  <td>
  <font face="Arial" size="3">
   Your Shopping Cart
  </font>
  </td>
</tr>
<tr>
  <td>
<asp:DataGrid
  id="dgrdShoppingCart"
  OnItemCommand="LinkButton_Click"
  AutoGenerateColumns="False"
  GridLines="Horizontal"
  BackColor="White"
  BorderStyle="Solid"
  BorderColor="Black"
  BorderWidth="2"
  Width="200"
  CellPadding="4"
  Font-Face="Arial"
  Font-Size="10pt"
  HeaderStyle-Font-Face="Arial"
  HeaderStyle-Font-Size="10pt"
  HeaderStyle-BackColor="orange"
  Runat="Server">
<Columns>
  <asp:TemplateColumn>
    <ItemTemplate>
    <asp:LinkButton
      Text="x"
      Style="color:red;font:bold 12pt Arial;text-decoration:none"
      Runat="Server" />
    </ItemTemplate>
  </asp:TemplateColumn> 
  <asp:BoundColumn
    DataField="ProductName" 
    HeaderText="item" />
  <asp:BoundColumn
    DataField="UnitPrice"
    DataFormatString="{0:c}" 
    HeaderText="price" />
  <asp:BoundColumn
    DataField="Quantity"
    HeaderText="qty" />
</Columns>
</asp:DataGrid>
  </td>
</tr>
<tr>
  <td align="right">
  Total: 
 <%=String.Format( "{0:c}", objShoppingCart.GetItemTotal() )%>
  </td>
</tr>
<tr>
  <td align="right">
  <asp:LinkButton
    id="btnAdd"
    Text="Add to Cart"
    OnClick="btnAdd_Click"
    Runat="Server" />
  &nbsp;&nbsp;
  <asp:HyperLink
    id="btnCheckOut"
    Text="Check Out"
    Runat="Server" />
  </td>
</tr>
</table>
  