<%@ Register TagPrefix="myControls" TagName="Address"
  Src="/aspnetstore/UserControls/Address.ascx" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>
<!-- #include virtual="/aspnetstore/includes/header.aspx" -->

<Script runat="Server">
Sub Page_Load
  If Not IsPostBack Then
    ViewState( "Category" ) = Context.Items( "Category" )
  End If

  If chkSameAddress.Checked Then
    ctrlBillingAddress.Validate = False
  Else
    ctrlBillingAddress.Validate= True
  End If
End Sub

Sub btnPlaceOrder_Click( s As Object, e As EventArgs )
  Dim strUserID As String
  Dim strConString As String
  Dim conMyData As SqlConnection
  Dim cmdOrders As SqlCommand
  Dim parmOrders AS SqlParameter

  If IsValid Then

  ' Retrieve the UserID
  strUserID = Request.Cookies( "StoreUserID" ).Value

  ' Copy shipping address to billing
  If chkSameAddress.Checked Then
    ctrlBillingAddress.Street = ctrlShippingAddress.Street
    ctrlBillingAddress.City = ctrlShippingAddress.City
    ctrlBillingAddress.State = ctrlShippingAddress.State
    ctrlBillingAddress.ZIP = ctrlShippingAddress.ZIP
  End If

  ' Create SQL command to execute PlaceOrder stored procedure
  strConString = ConfigurationSettings.AppSettings( "connectionString" )
  conMyData = New SqlConnection( strConString )
  cmdOrders = New SqlCommand( "PlaceOrder", conMyData )
  cmdOrders.CommandType = CommandType.StoredProcedure
  
  ' Create a billion parameters
  parmOrders = cmdOrders.Parameters.Add( "@UserID", SqlDbType.UniqueIdentifier )
  parmOrders.Value = New GUID( strUserID )
  cmdOrders.Parameters.Add( "@firstname", txtFirstName.Text )
  cmdOrders.Parameters.Add( "@lastname", txtLastName.Text )
  cmdOrders.Parameters.Add( "@billStreet", ctrlBillingAddress.Street )
  cmdOrders.Parameters.Add( "@billCity", ctrlBillingAddress.City )
  cmdOrders.Parameters.Add( "@billState", ctrlBillingAddress.State )
  cmdOrders.Parameters.Add( "@billZIP", ctrlBillingAddress.ZIP )
  cmdOrders.Parameters.Add( "@shipStreet", ctrlShippingAddress.Street )
  cmdOrders.Parameters.Add( "@shipCity", ctrlShippingAddress.City )
  cmdOrders.Parameters.Add( "@shipState", ctrlShippingAddress.State )
  cmdOrders.Parameters.Add( "@shipZIP", ctrlShippingAddress.ZIP )

  conMyData.Open()
    cmdOrders.ExecuteNonQuery
  conMyData.Close()

  Response.Redirect( "ThankYou.aspx" )  
  End If    
End Sub

Sub btnCancel_Click( s As Object, e As EventArgs )
  Dim strCategory As String

  strCategory = ViewState( "Category" )
  Response.Redirect( String.Format( _
    "Category.aspx?cat={0}", strCategory ) )
End Sub
</Script>

<html>
<head>
<link href="/aspnetstore/Styles/Store.css" type="text/css" rel="stylesheet" />
<title>Confirm Order</title>
</head>
<body bgcolor="lightblue">
<a href="Default.aspx"><img src="banner.gif" border="1"></a>
<form runat="Server">

<myControls:Tabs
  Runat="Server" />
<table width="800" height="100%" cellpadding="10" 
  cellspacing="0" border="0">
<tr>
  <td width="100%" valign="top" bgcolor="white">

  <div class="formBox">
  <span class="formHeading">Contact Information</span>
  <p>
  Your First Name
  <asp:RequiredFieldValidator
    Text="(required)"
    ControlToValidate="txtFirstName"
    Runat="Server" />
  <br>
  <asp:TextBox
    id="txtFirstName"
    Runat="Server" />
  <p> 
  Your Last Name
  <asp:RequiredFieldValidator
    Text="(required)"
    ControlToValidate="txtLastName"
    Runat="Server" />
  <br>
  <asp:TextBox
    id="txtLastName"
    Runat="Server" />
  </div>
<p>
  <div class="formBox">
  <span class="formHeading">Shipping Information</span>
  <p>
  Shipping Address
  <br>
  <myControls:Address
    id="ctrlShippingAddress"
    Runat="Server" />
  <p> 
  Billing Address
  <br>
  <asp:Checkbox
    id="chkSameAddress"
    Runat="Server" />
  Check here if billing address is same as shipping
  <br>
  <myControls:Address
    id="ctrlBillingAddress"
    Runat="Server" />
  </div>
<p>
  <div>
  <asp:Button
    id="btnCancel"
    Text="Cancel"
    OnClick="btnCancel_Click"
    CausesVaidation="False"
    Runat="Server" />
  &nbsp;&nbsp;&nbsp;
  <asp:Button
    id="btnPlaceOrder"
    OnClick="btnPlaceOrder_Click"
    Text="Place Order!"
    Runat="Server" />
  </div>

  </td>
</tr>
</table>

</form>

<!-- #include virtual="/aspnetstore/includes/footer.aspx" -->